Option Explicit
' $URL: https://opensvn.csie.org/TinyCollection/PSPad/trunk/code/svncmd.vbs $
' $Author: DonQuichote $
' $Date: 2006-09-28 19:58:13 +0200 (Thu, 28 Sep 2006) $
' $Revision: 35 $

Const module_name = "Subversion" ' This name must be unique.
Const module_desc = "Routines for the Subversion source code control system"
Const module_ver = "0.1" ' Version

' ToDo [willemb]: Devide the menu in Single file, Open files and Project files
'If True, the "Edit this script" option is added to the menu. Handy when debugging.
Const ADD_EDIT_ME_TO_MENU = True
Const cPROJECT_IS_IN_CVS = False' Set to True if you want the PSPad projects in CVS as well. However, beware of conflict situations.

'CVS settings
const sCVS_EXECUTABLE = "C:\Program Files\Subversion\bin\svn.exe"
'Example for CVS: const sCVS_EXECUTABLE = "C:\Program Files\TortoiseCVS\cvs.exe"
'CVS commands. Variables %Input%, %File%, %FullFileName%, %FilePath%, %FileName% and %FileName2% are expanded.
'%Input% is replaced by the value of an inputbox. For the other values, see the PSPad documentation about variables.
const cCVS_ADD = "add -m ""%Input%"" ""%FileName%"""
const cCVS_ANNOTATE = "annotate ""%FileName%"""
const cCVS_COMMIT = "commit -m ""%Input%"" ""%FileName%"""
const cCVS_GET_CLEAN_COPY = "revert ""%FileName%"""
const cCVS_LOG = "log ""%FileName%"""
const cCVS_STATUS = "status -q ""%FileName%"""
const cCVS_FULL_STATUS = "status --show-updates --verbose ""%FileName%"""
const cCVS_UPDATE = "update ""%FileName%"""
const cCONFLICT_EDITOR = ""
const cPROJECT_DIRECTORY = "C:\projects\"
'Example for CVS:
' const cCVS_ADD = "add -m ""%Input%"" ""%FileName%"""
' const cCVS_ANNOTATE = "annotate ""%FileName%"""
' const cCVS_COMMIT = "commit -m ""%Input%"" ""%FileName%"""
' const cCVS_GET_CLEAN_COPY = "update -C ""%FileName%"""
' const cCVS_LOG = "log -S ""%FileName%"""
' const cCVS_STATUS = "status -q ""%FileName%"""
' const cCVS_FULL_STATUS = "status ""%FileName%"""
' const cCVS_UPDATE = "update ""%FileName%"""
' const cCONFLICT_EDITOR = """C:\Program Files\CvsConflictEditor\CvsConflictEditor.Exe"" ""%File%"""
' const cPROJECT_DIRECTORY = "D:\development\source\Projects\"

'Language settings
Const cMENU_EDIT_ME = "Edit this script"
Const cMENU_EDIT_PROJECT_FILE="Edit selected project file"
Const cMENU_ADD = "Add file"
Const cMENU_ANNOTATE = "Annotate file"
Const cMENU_COMMIT = "Commit file"
Const cMENU_GET_CLEAN_COPY = "Get clean copy of file"
Const cMENU_LOG = "File log"
Const cMENU_STATUS = "File status"
Const cMENU_FULL_STATUS = "Full file status"
Const cMENU_UPDATE = "Update file"
Const cMENU_CONFLICT_EDIT = "Resolve conflict"
Const cMENU_PROJECT_COMMIT = "Commit all in project"
Const cMENU_PROJECT_UPDATE = "Update all in project"
Const cMENU_PROJECT_GET_CLEAN_COPY = "Get all clean copies in project"
Const cMENU_PROJECT_STATUS = "Read Entire project status."
Const cMENU_PROJECT_FULL_STATUS = "Read Entire, full project status."
'Const cMENU_PROJECT_ = ""
'Const cMENU_PROJECT_ = ""
'--- End of Settings ---

Const cDIRECTORY_SEPARATOR = "\"
Const cCVS_JUNK_MASK = ".#*"

Sub AddToMenu(ByVal strLabel, ByVal strFunction)
 If Len(strLabel)>0 Then
   addMenuItem strLabel, "&" & module_name, strFunction
 End If
End Sub

Function CurrentFile()
 With newEditor
     .assignActiveEditor
     CurrentFile = .fileName
 End With
End Function

Function DirectoryOf(ByVal strFullPath)
 Dim numPos
 numPos = InStrRev(strFullPath, "\")
 DirectoryOf = Left(strFullPath, numPos)
End Function

Sub DoCvsAdd()
 RunCvsCommand cCVS_ADD, DirectoryOf(CurrentFile()), cMENU_ADD
End Sub

Sub DoCvsAnnotate()
 RunCvsCommand cCVS_ANNOTATE, DirectoryOf(CurrentFile()), cMENU_ANNOTATE
End Sub

Sub DoCvsCommit()
 With newEditor()
      .assignActiveEditor()
      .saveFile()
 End With
 RunCvsCommand cCVS_COMMIT, DirectoryOf(CurrentFile()), cMENU_COMMIT
 ReloadCurrentFile ' For keyword expansion.
End Sub

Sub DoCvsCommitAll()
 RunCvsForAll cCVS_COMMIT, cMENU_PROJECT_COMMIT
End Sub

Sub DoCvsGetCleanCopy()
 RunCvsCommand cCVS_GET_CLEAN_COPY, DirectoryOf(CurrentFile()), cMENU_GET_CLEAN_COPY
 ReloadCurrentFile
End Sub

Sub DoCvsCleanCopyForAll()
 RunCvsForAll cCVS_GET_CLEAN_COPY, cMENU_PROJECT_GET_CLEAN_COPY
End Sub

Sub DoCvsLog()
 RunCvsCommand cCVS_LOG, DirectoryOf(CurrentFile()), cMENU_LOG
End Sub

Sub DoCvsStatus()
 RunCvsCommand cCVS_STATUS, DirectoryOf(CurrentFile()), cMENU_STATUS
End Sub

Sub DoCvsStatusAll()
 RunCvsForAll cCVS_STATUS, cMENU_PROJECT_STATUS
End Sub

Sub DoCvsFullStatus()
 RunCvsCommand cCVS_FULL_STATUS, DirectoryOf(CurrentFile()), cMENU_FULL_STATUS
End Sub

Sub DoCvsFullStatusAll()
 RunCvsForAll cCVS_FULL_STATUS, cMENU_PROJECT_FULL_STATUS
End Sub

Sub DoCvsUpdate()
 RunCvsCommand cCVS_UPDATE, DirectoryOf(CurrentFile()), cMENU_UPDATE
 ReloadCurrentFile
End Sub

Sub DoCvsUpdateAll()
 RunCvsForAll cCVS_UPDATE, cMENU_PROJECT_UPDATE
End Sub

Sub EditMe()
 newEditor.openFile moduleFileName(module_name)
 If False Then
   NeverExecuteThis' undefined sub
 End If
End Sub

Sub EditProjectFile()
 Dim strProjectDir, strSelection
 strProjectDir = cPROJECT_DIRECTORY
 If Right(strProjectDir,1)<>"\" Then
    strProjectDir = strProjectDir & "\"
 End If
 With newEditor
      .assignActiveEditor
      strSelection = .selText()
      If Len(strSelection)>0 Then
         newEditor().openFile strProjectDir & BackSlashed(strSelection)
      End If
 End With
'  If Len(strSelection)>0 Then
'     With newEditor
'          
'     End With
'  End If
End Sub

Function BackSlashed(strPath)
 Dim numPos
 numPos = InStr(1, strPath, "/")
 While numPos>0
       strPath = Left(strPath, numPos - 1) & "\" & Mid(strPath, numPos + 1)
       numPos = InStr(1, strPath, "/")
 Wend
 BackSlashed = strPath
End Function

' name "Init" is required, its called automatically during initialization to create menu items
' addMenuItem "Name of menu item", "Name of submenu if required", "Main"
Sub Init
 With New clsAccesskeyGenerator
      .WithAccessKey(module_name) ' So the first character of the module is not used for commands
      AddToMenu .WithAccessKey(cMENU_UPDATE), "DoCvsUpdate"
      AddToMenu .WithAccessKey(cMENU_COMMIT), "DoCvsCommit"
      AddToMenu .WithAccessKey(cMENU_GET_CLEAN_COPY), "DoCvsGetCleanCopy"
      AddToMenu .WithAccessKey(cMENU_ADD), "DoCvsAdd"
      AddToMenu .WithAccessKey(cMENU_LOG), "DoCvsLog"
      AddToMenu .WithAccessKey(cMENU_STATUS), "DoCvsStatus"
      AddToMenu .WithAccessKey(cMENU_FULL_STATUS), "DoCvsFullStatus"
      AddToMenu .WithAccessKey(cMENU_ANNOTATE), "DoCvsAnnotate"
      If Len(cCONFLICT_EDITOR)>0 Then
         AddToMenu .WithAccessKey(cMENU_CONFLICT_EDIT), "ResolveConflict"
      End If
      If Len(cPROJECT_DIRECTORY)>0 Then
         AddToMenu .WithAccessKey(cMENU_EDIT_PROJECT_FILE), "EditProjectFile"
      End If
      If IsProjectAvailable Then
         AddToMenu "-", ""
         AddToMenu .WithAccessKey(cMENU_PROJECT_UPDATE), "DoCvsUpdateAll"
         AddToMenu .WithAccessKey(cMENU_PROJECT_COMMIT), "DoCvsCommitAll"
         AddToMenu .WithAccessKey(cMENU_PROJECT_GET_CLEAN_COPY), "DoCvsCleanCopyForAll"
         AddToMenu .WithAccessKey(cMENU_PROJECT_FULL_STATUS), "DoCvsFullStatusAll"
     '  AddToMenu .WithAccessKey(cMENU_), "DoCvs"
      End If
      If ADD_EDIT_ME_TO_MENU Then
         AddToMenu "-", ""
         AddToMenu .WithAccessKey(cMENU_EDIT_ME), "EditMe"
      End If
 End With
End Sub

Function IsProjectAvailable()
 Const FIRST_VERSION_WITH_PROJECTREADING = 2181
 Dim varVersion, numPos
 varVersion = pspadVersion
 If Right(varVersion, 1)=")" Then
   varVersion = Left(varVersion, Len(varVersion) - 1)
 End If
 numPos = InStr(1, varVersion, "(")
 If numPos>0 Then
   varVersion = Mid(varVersion, numPos + 1)
 End If
 IsProjectAvailable = (CInt(varVersion)>=FIRST_VERSION_WITH_PROJECTREADING)
End Function

Sub ReloadCurrentFile() 'built-in function does not work
 Dim numLine
 With newEditor()
     .assignActiveEditor
     numLine = .caretY
     .openFile CurrentFile()
     .caretY(numLine)
 End With
End Sub

Sub RemoveCvsJunk()
 Dim strFullMask, edtLog
 strFullMask = cPROJECT_DIRECTORY & cCVS_JUNK_MASK
 Set edtLog = newEditor()
 edtLog.assignLog()
 ' ToDo [willemb]: Parse the complete folder structure. Yuck.
End Sub


Sub ResolveConflict()
 With CreateObject("WScript.Shell")
     .Run WithVariablesSubstituted(cCONFLICT_EDITOR, CurrentFile), 1, True
 End With
End Sub

Sub RunCvsCommand(Byval strCommand, Byval strDirectory, ByVal strInputTitle)
 Dim objLogger
 Set objLogger = New ProcessLogger
 With CreateObject("WScript.Shell")
      .CurrentDirectory = strDirectory
      objLogger.FollowProcess .Exec(WithVariablesSubstituted("""" & sCVS_EXECUTABLE & """ " & strCommand, CurrentFile, strInputTitle)), CurrentFile
 End With
End Sub

Sub RunCvsForAll(ByVal strCommand, ByVal strInputTitle)
 Dim intCount
 Dim objLogger
 If projectFilesCount>0 Then
    Set objLogger = New ProcessLogger
    strCommand = WithInput(strCommand)
    With CreateObject("WScript.Shell")
        For intCount = 0 To projectFilesCount - 1
           .CurrentDirectory = DirectoryOf(projectFiles(intCount))
           objLogger.FollowProcess .Exec(WithVariablesSubstituted("""" & sCVS_EXECUTABLE & """ " & strCommand, projectFiles(intCount), strInputTitle)), projectFiles(intCount)
        Next
    End With
 Else
   With newEditor()
        .assignLog
        .text "There are no files in the current project."
   End With
 End If
End Sub

Function Substitute(strHaystack, strNeedle, strNewHay)
 Dim numPos
 numPos = InStr(1, strHaystack, strNeedle)
 If numPos>0 Then
   strHaystack = Left(strHaystack, numPos - 1) & strNewHay & Mid(strHaystack, numPos + Len(strNeedle))
 End If
 Substitute = strHaystack
End Function

Function WithInput(Byval strCommand, ByVal strInputCaption)
 Dim numPos
 numPos = InStr(1, strCommand, "%Input%")
 While numPos>0
      strCommand = Substitute(strCommand, "%Input%", InputBox("Comment:", strInputCaption))
      numPos = InStr(1, strCommand, "%Input%")
 Wend
 WithInput = strCommand
End Function

Function WithVariablesSubstituted(Byval strCommand, Byval strFile, ByVal strInputCaption)
 Dim numPos
 strCommand = Substitute(strCommand, "%FullFileName%", strFile)
 strCommand = Substitute(strCommand, "%File%", strFile)
 numPos = InStrRev(strFile, "\")
 If numPos>0 Then
   strCommand = Substitute(strCommand, "%FilePath%", Left(strFile, numPos))
   strFile = Mid(strFile, numPos + 1)
   strCommand = Substitute(strCommand, "%FileName%", strFile)
   numPos = InStrRev(strFile, ".")
   If numPos>0 Then
     strCommand = Substitute(strCommand, "%FileName2%", Left(strFile, numPos - 1))
   End If
 End If
 WithVariablesSubstituted = WithInput(strCommand, strInputCaption)
End Function

Class clsAccesskeyGenerator
 Dim mstrKeys
 
 Private Sub Class_Initialize()
    mstrKeys = ""
 End Sub
 
 Public Function WithAccessKey(ByVal strCommand)
    Dim numPos, strKey
    numPos=1
    ' ToDo [willemb]: Make sure whitespace cannot get an accesskey
    While (InStr(1, mstrKeys, UCase(Mid(strCommand, numPos, 1)))>0) And (numPos<=Len(strCommand))
         numPos = numPos + 1
    Wend
    If numPos<=Len(strCommand) Then
      mstrKeys = mstrKeys & UCase(Mid(strCommand, numPos, 1))
      strCommand = Left(strCommand, numPos - 1) & "&" & Mid(strCommand, numPos)
    End If
    WithAccessKey = strCommand
 End Function
End Class

Class ProcessLogger
 Private medtOutput
 Private mnumPrintedCharacters

 Private Sub Class_Initialize()
    Set medtOutput = newEditor()
    medtOutput.assignLog
    medtOutput.text ""
 End Sub

 Public Function FollowProcess(ByVal objProcess, ByVal strFileName)
  Dim strOutput, numResult
  mnumPrintedCharacters = 0
  With objProcess
      While .Status=0
           strOutput = .StdOut.ReadAll
           If Len(strOutput)>mnumPrintedCharacters Then
             medtOutput.appendText Mid(strOutput, mnumPrintedCharacters + 1)
             mnumPrintedCharacters = Len(strOutput)
           End If
      Wend
      numResult = .ExitCode
      FollowProcess = .ExitCode
      If numResult<>0 Then
        medtOutput.appendText " error processing " & strFileName & Chr(10)
      End If
  End With
 End Function
End Class
